;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
;
; Copyright (C) 2002 Xavier Fenard tout droits rservs. Autorisation
; est donne pour utiliser, modifier ou distribuer ce logiciel tant qu'il
; n'est pas vendu ou exploit pcuniairement.
; CE LOGICIEL EST DONNE TEL QUEL ET SANS AUCUNE GARANTIE, NI EXPLICITE OU IMPLICITE
;
;
; Copyright (C) 2002 Xavier Fenard All rights reserved. Permission
; is granted to use, modify, or redistribute this software so long as it is
; not sold or exploited for profit.
; THIS SOFTWARE IS PROVIDED AS IS AND WITHOUT WARRANTY OF ANY KIND, EITHER
; EXPRESSED OR IMPLIED.
;
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;
;
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;



            save          ; sauve etat de listing...  
;            listing off   ;pas de listing

;*---------------------------------------------------------------------------*/
;gestion LCD 1er configuration, attention LCDD7<>PORTB4...LCDD4<>PORTB7   

#ifdef FoncLCD1

;hardware
; Port B        bit         2       RS      Register Select command=0, data=1      
;                           3       OE      Enable - clocks on neg transition                          
;               bits    4-7     data    4 bits, high nibble first ASCII format                                       
;               RW grounded (write)     
; Note that commands take up to 1.6 msec for display to implement
; at a nominal display clock rate of 250 KHz
; Display initialize routine after power up
; 
;************************************************************************

;definir si affichage 1*16
LCDLM40



LCDInit:
    ldi     temp,0b11000000         ; System set 0x03
    out     PORTB,temp
    ldi delayms,150                 ; Wait at least 15msec after                           
    rcall   WAIT_Xmsec              ; powerup before writing  to display
    ldi     temp,0x33               ;0x33 synchro 8 bits le fait en deux fois
    rcall   COMMAND_DISPLAY         ;    
    ldi     temp,0x40               ;0x2 Function set 4 bit mode
    out     PORTB,temp
    nop
    nop
    rcall    LCDPulse    
    ldi     temp,0x28               ;0x28 Function set 4 bit mode, 1 lines 5X7 pixels
    rcall   COMMAND_DISPLAY         ;write to display
    rcall   LCDClr
    ldi     temp,0x0C                ;0x0C Display on, cursor off blink off
    rcall   COMMAND_DISPLAY    
    ldi     temp,0x06                ;0x06 ENTRY MODE SET SHIFT DROITE
    rcall   COMMAND_DISPLAY         ;

LCDHome
	ifdef LCDLM40
	clr temp
	sts LCDLM40P,temp		  ;position 0	
	endif 
	ldi     temp,0x2            ;0x02 home
     rjmp LCDC2ms

LCDClr  ldi     temp,0x1            ; 0x01 Display clear
LCDC2ms    rcall   COMMAND_DISPLAY
    rjmp   WAIT_2msec               ; Need to wait 1.6 msec after clear



;************************************************
; Write command/data to display
; command/data word in temp
; built in 50 usec delay
; uses temp_1 and T bit in SREG
;
;************************************************
DATA_DISPLAY:
	ifdef LCDLM40
	push temp
	lds temp,LCDLM40P
	inc temp
	sts LCDLM40P,temp
	cpi temp, 0x10
	brlo LCDLM01
	rcall LCDHome		;retour, max 16
	rjmp LCDLM00F
LCDLM01 cpi temp,0x09 
	brne LCDLM00F
	ldi temp,0xC0		;position 8
	rcall  COMMAND_DISPLAY
LCDLM00F	pop temp
	endif
        set                             ; Uses bit T in SREG to
        rjmp    CONT_DISPLAY            ; store bit for data/command
COMMAND_DISPLAY:
        clt                             ; data/command bit low
CONT_DISPLAY:
        rcall LCDSWP
        swap    temp                    ; get lower 4 bits
        rcall LCDSWP
        ldi     delayms,1               ; Wait about 50 usec   
        rjmp    WAIT_Xmsec              ;us100

LCDSWP  cbi PORTB,7
	   cbi PORTB,6
	   cbi PORTB,5
	   cbi PORTB,4
	   sbrc temp,7                 ;skp clr
	   sbi PORTB,4                 ;set bit
	   sbrc temp,6                 ;skp clr
	   sbi PORTB,5                 ;set bit
	   sbrc temp,5                 ;skp clr
	   sbi PORTB,6                 ;set bit
	   sbrc temp,4                 ;skp clr
        sbi PORTB,7                 ;set bit
	   cbi PORTB,2				 ;command/data
	   brtc LCDSWPT
	   sbi PORTB,2				 ;command/data
LCDSWPT nop
	   nop

LCDPulse sbi     PORTB,3                ; OE high to clock in data
        push temp                       ;2 
        pop   temp                      ; min E: 450ns 
        push temp                       ;2 
        pop   temp                      ; min E: 450ns 
        push temp                       ;2 
        pop  temp                       ; min E: 450ns 
        cbi     PORTB,3                 ; OE low to clock in data
        ret


 
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;Automate d'affichage d'une chaine de caractere

;0x20..7F   affiche le caractere code ASCII 
;0x8x       fin d'affichage
;0x9x       position sur l'afficheur
;0xAx       position sur l'afficheur
;0xBx       commande 0x0x 40us
;0xCx       commande 0x0x 2ms
;0xE0..FF   affiche le caractere code ASCII (symbole)

;Z base string
LCDStringH
	rcall LCDHome
LCDString
    lpm                           ;get constant dans R0
    sbrc r0,7
    rjmp LCDStringC
LCDString1    mov temp,r0         ;ASCII   
    rcall   DATA_DISPLAY
LCDString2    adiw    ZL,1        ;increment Z-pointer
    rjmp LCDString
    
LCDStringC
    mov temp,r0
    mov temp_1,r0
    andi temp,0x0F
    andi temp_1,0xF0    ;min 0x80
    subi temp_1,0x80
    brne LCDStringC0
    ret                 ;0x80...0x8F: fin
LCDStringC0    
    subi temp_1,0x10
    brne LCDStringC1
    sbr temp,0x80       ;0x90 commande: set ADD 
    rjmp LCDStringCC
LCDStringC1 
    subi temp_1,0x10
    brne LCDStringC2
    sbr temp,0xC0       ;0xA0 commande: set ADD (40H)
    rjmp LCDStringCC
LCDStringC2
    subi temp_1,0x10
    brne LCDStringC3
    rjmp LCDStringCC    ;0xB0 commande: type 0x0x (40us)
LCDStringC3
    subi temp_1,0x10
    brne LCDStringC4
    rcall LCDC2ms
    rjmp LCDString2     ;0xC0 commande: type 0x0x (2ms)
LCDStringC4
    rjmp LCDString1     ;caractere symbole
    
LCDStringCC    rcall  COMMAND_DISPLAY 
    rjmp LCDString2
    
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;affiche un bin 16 bits en decimal
#ifdef FoncLCDHex16Dec


;zl, zh la valeur a afficher
;R24 R25: valeur soustractive        
#define bdr20 r16
#define bdr21 r17
#define bdr22 r18
#define bdr23 r19
#define bdr24 r20
#define bdr25 r21


LCDDec
;    clt                     ; 'Blank' leading zeros flag
    set                      ; afiche tous les zero
_printdec_alt
    clr     bdr20
    clr     bdr21
    clr     bdr22
    clr     bdr23
    ldi     bdr24,0x10    ; 10,000 dec
    ldi     bdr25,0x27
    rcall   _pdcount    ; See how many times we can subtract 10,000
    ldi     bdr24,0xe8    ; 1,000 dec
    ldi     bdr25,0x03
    rcall   _pdcount    ; See how many times we can subtract 1,000
    ldi     bdr24,100     
    clr     bdr25
    rcall   _pdcount    ; How many times can we subtract 100
    ldi     bdr24,10
    rcall   _pdcount    ; And 10s
    subi    zl,-'0'     ; The residual should be 0-9, convert to ASCII
    mov     temp, zl
    rjmp    DATA_DISPLAY   ; Go print the last char. (At least 1 digit is printed!)
;

_pdcount:
    ldi       temp,'0'             ; Initialize count to Ascii '0'
_pdcountlp:
    cp      zl,bdr24              ; non-destructive Compare 'prim to sec'
    cpc     zh,bdr25              ; If we subtracted, would we have to 'borrow' a bit ?
    cpc     bdr22,bdr20
    cpc     bdr23,bdr21
    brlo    _pdigit               ; Yes, so we are done.
    sub     zl,bdr24              ; No, subtract the secondary from the primary.
    sbc     zh,bdr25
    sbc     bdr22,bdr20
    sbc     bdr23,bdr21
    inc     temp                    ; Add 1 to 'counter'
    brne    _pdcountlp              ; Keep doing this until an underflow would occur.
_pdigit:                        
    brts      _pdigit1              ; No leading '0's  for 'pretty' output. If the 'T'
    cpi       temp,'0'              ;  flag is clear, AND the digit = '0', skip the 'print'
    breq      _pdigit2
    set                             ; Our first 'non-zero' digit. Set the 'T' flag for
_pdigit1  rjmp    DATA_DISPLAY      ;affichage
_pdigit2:
    ret                             ; Must have been a 'leading' zero, return to caller
#endif
      
        
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;Affiche un hex 

    ifdef FoncHEXLCD

LCDHEX  push temp
        swap temp
        rcall LCDHEX1
        pop temp
LCDHEX1  andi temp,0x0F              ;low
        subi temp,10
        brvs LCDHEX2    
        subi 256-7                  ;add 7
LCDHEX2 subi 256-(0x30-10)          ; add 0x30-10
        rjmp DATA_DISPLAY
    ENDIF

 
 
         
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;

    IF 0
.macro   LCD_Cls
         ldi CommandReg,0b00000001
         rcall LCD_Command 
         rcall delay4ms
         ldi LCD_Xpos,0
         ldi LCD_Ypos,1 
         .endmacro

.macro   LCD_Home
         ldi CommandReg,0b00000010
         rcall LCD_Command 
         rcall delay4ms
         ldi LCD_Xpos,0
         ldi LCD_Ypos,1
         .endmacro

.macro   LCD_On
         ldi CommandReg,0b00001100
         rcall LCD_Command 
         rcall delay40us
         .endmacro

.macro   LCD_Off
         ldi CommandReg,0b00001000
         rcall LCD_Command 
         rcall delay40us
         .endmacro

.macro   LCD_CursorOn
         ldi CommandReg,0b00001110
         rcall LCD_Command 
         rcall delay40us
         .endmacro

.macro   LCD_CursorOff
         ldi CommandReg,0b00001100
         rcall LCD_Command 
         rcall delay40us
         .endmacro
.macro   LCD_BlinkOn
         ldi CommandReg,0b00001111
         rcall LCD_Command 
         rcall delay40us
         .endmacro
.macro   LCD_BlinkOff
         ldi CommandReg,0b00001110
         rcall LCD_Command 
         rcall delay40us
         .endmacro
.macro   LCD_ShiftCursorL
         ldi CommandReg,0b00010000
         rcall LCD_Command 
         rcall delay40us 
         .endmacro
.macro   LCD_ShiftCursorR
         ldi CommandReg,0b00010100
         rcall LCD_Command 
         rcall delay40us 
         .endmacro

.macro   LCD_ShiftDisplayL
         ldi CommandReg,0b00011000
         rcall LCD_Command 
         rcall delay40us 
         .endmacro
.macro   LCD_ShiftDisplayR
         ldi CommandReg,0b00011100
         rcall LCD_Command 
         rcall delay40us 
         .endmacro

    ENDIF
 
 
         
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;


 
 
         
;*---------------------------------------------------------------------------*/
;*                                                                           */
;*                                                                           */
;*---------------------------------------------------------------------------*/
;

 
 
 #endif 
 
 ;*---------------------------------------------------------------------------*/
 ;*                                                                           */
 ;*                                                                           */
 ;*---------------------------------------------------------------------------*/
 ;
 
        
     restore                 ;replace la config  
